using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadGridViewComboElement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Value", typeof(int));
            Random r = new Random();
            for (int i = 0; i < 10; i++)
            {
                table.Rows.Add(i, "Row " + i, r.Next(3));
            }
            this.radGridView1.Columns.Clear();
            this.radGridView1.DataSource = table;
            this.radGridView1.ReadOnly = true;
            this.radGridView1.CellFormatting += new Telerik.WinControls.UI.CellFormattingEventHandler(radGridView1_CellFormatting);
        }

        void radGridView1_CellFormatting(object sender, Telerik.WinControls.UI.CellFormattingEventArgs e)
        {
            if(e.CellElement.RowIndex >=0)
            {
                if (e.CellElement.ColumnIndex == 2)
                {
                    RadComboBoxElement box = null;
                    if (e.CellElement.Children.Count == 0)
                    {
                        List<Item> items = new List<Item>();
                        items.Add(new Item(0, "Zero"));
                        items.Add(new Item(1, "One"));
                        items.Add(new Item(2, "Two"));
                        items.Add(new Item(3, "Three"));

                        box = new RadComboBoxElement();
                        box.DataSource = items;
                        box.DisplayMember = "Name";
                        box.ValueMember = "Id";
                        box.EndInit();
                        box.SelectedIndexChanged += new EventHandler(box_SelectedIndexChanged);
                        box.Children[2].Children[1].Children[2].AutoSize = true;
                        e.CellElement.Children.Add(box);
                    }
                    else
                    {
                        box = (RadComboBoxElement)e.CellElement.Children[0];
                    }
                    box.SelectedValue = ((GridDataCellElement)e.CellElement).Value;
                }
            }
        }

        void box_SelectedIndexChanged(object sender, EventArgs e)
        {
            RadComboBoxElement combo = (RadComboBoxElement)sender;
            GridDataCellElement cell = (GridDataCellElement)combo.Parent;
            cell.Value = combo.SelectedValue;
        }

        public class Item
        {
            private int id;
            private string name;

            public Item()
            {
            }

            public Item(int id, string name)
            {
                this.id = id;
                this.Name = name;
            }

            public int Id 
            {
                get
                {
                    return id;
                }
                set
                {
                    id = value;
                }
            }
            public string Name 
            {
                get
                {
                    return name;
                }
                set
                {
                    name = value;
                }
            }
        }
    }
}